/************************************************************************/
/*									*/
/* ̤ɽ		16bpp						*/
/*									*/
/************************************************************************/

#include <string.h>

#include "quasi88.h"
#include "screen.h"
#include "screen-func.h"
#include "crtcdmac.h"
#include "memory.h"
#include "q8tk.h"


#ifdef	SUPPORT_16BPP

#define TYPE		bit16

#define SCREEN_WIDTH		WIDTH
#define SCREEN_HEIGHT		HEIGHT
#define SCREEN_SX		SCREEN_W
#define SCREEN_SY		SCREEN_H
#define SCREEN_TOP		screen_buf
#define SCREEN_START		screen_start

#define COLOR_PIXEL(x)		(TYPE) color_pixel[ x ]
#define MIXED_PIXEL(a,b)	(TYPE) color_half_pixel[ a ][ b ]
#define BLACK			(TYPE) black_pixel

/*===========================================================================
 * ܥ
 *===========================================================================*/

/*----------------------------------------------------------------------
 *			 200饤			ɸ
 *----------------------------------------------------------------------*/
#define NORMAL

#define COLOR						/* 顼640x200 */
#define		TEXT_WIDTH	80
#define		TEXT_HEIGHT		25
#define		VRAM2SCREEN_DIFF		v2s_dif_C80x25_F_N_16
#define		VRAM2SCREEN_ALL			v2s_all_C80x25_F_N_16
#include					"screen-vram-full.h"
#define		TEXT_WIDTH	80
#define		TEXT_HEIGHT		20
#define		VRAM2SCREEN_DIFF		v2s_dif_C80x20_F_N_16
#define		VRAM2SCREEN_ALL			v2s_all_C80x20_F_N_16
#include					"screen-vram-full.h"
#define		TEXT_WIDTH	40
#define		TEXT_HEIGHT		25
#define		VRAM2SCREEN_DIFF		v2s_dif_C40x25_F_N_16
#define		VRAM2SCREEN_ALL			v2s_all_C40x25_F_N_16
#include					"screen-vram-full.h"
#define		TEXT_WIDTH	40
#define		TEXT_HEIGHT		20
#define		VRAM2SCREEN_DIFF		v2s_dif_C40x20_F_N_16
#define		VRAM2SCREEN_ALL			v2s_all_C40x20_F_N_16
#include					"screen-vram-full.h"
#undef	COLOR

#define MONO						/* 	 640x200 */
#define		TEXT_WIDTH	80
#define		TEXT_HEIGHT		25
#define		VRAM2SCREEN_DIFF		v2s_dif_M80x25_F_N_16
#define		VRAM2SCREEN_ALL			v2s_all_M80x25_F_N_16
#include					"screen-vram-full.h"
#define		TEXT_WIDTH	80
#define		TEXT_HEIGHT		20
#define		VRAM2SCREEN_DIFF		v2s_dif_M80x20_F_N_16
#define		VRAM2SCREEN_ALL			v2s_all_M80x20_F_N_16
#include					"screen-vram-full.h"
#define		TEXT_WIDTH	40
#define		TEXT_HEIGHT		25
#define		VRAM2SCREEN_DIFF		v2s_dif_M40x25_F_N_16
#define		VRAM2SCREEN_ALL			v2s_all_M40x25_F_N_16
#include					"screen-vram-full.h"
#define		TEXT_WIDTH	40
#define		TEXT_HEIGHT		20
#define		VRAM2SCREEN_DIFF		v2s_dif_M40x20_F_N_16
#define		VRAM2SCREEN_ALL			v2s_all_M40x20_F_N_16
#include					"screen-vram-full.h"
#undef	MONO

#define UNDISP						/* ɽ640x200 */
#define		TEXT_WIDTH	80
#define		TEXT_HEIGHT		25
#define		VRAM2SCREEN_DIFF		v2s_dif_U80x25_F_N_16
#define		VRAM2SCREEN_ALL			v2s_all_U80x25_F_N_16
#include					"screen-vram-full.h"
#define		TEXT_WIDTH	80
#define		TEXT_HEIGHT		20
#define		VRAM2SCREEN_DIFF		v2s_dif_U80x20_F_N_16
#define		VRAM2SCREEN_ALL			v2s_all_U80x20_F_N_16
#include					"screen-vram-full.h"
#define		TEXT_WIDTH	40
#define		TEXT_HEIGHT		25
#define		VRAM2SCREEN_DIFF		v2s_dif_U40x25_F_N_16
#define		VRAM2SCREEN_ALL			v2s_all_U40x25_F_N_16
#include					"screen-vram-full.h"
#define		TEXT_WIDTH	40
#define		TEXT_HEIGHT		20
#define		VRAM2SCREEN_DIFF		v2s_dif_U40x20_F_N_16
#define		VRAM2SCREEN_ALL			v2s_all_U40x20_F_N_16
#include					"screen-vram-full.h"
#undef	UNDISP

#undef	NORMAL
/*----------------------------------------------------------------------
 *			 200饤			饤󥹥å
 *----------------------------------------------------------------------*/
#define SKIPLINE

#define COLOR						/* 顼640x200 */
#define		TEXT_WIDTH	80
#define		TEXT_HEIGHT		25
#define		VRAM2SCREEN_DIFF		v2s_dif_C80x25_F_S_16
#define		VRAM2SCREEN_ALL			v2s_all_C80x25_F_S_16
#include					"screen-vram-full.h"
#define		TEXT_WIDTH	80
#define		TEXT_HEIGHT		20
#define		VRAM2SCREEN_DIFF		v2s_dif_C80x20_F_S_16
#define		VRAM2SCREEN_ALL			v2s_all_C80x20_F_S_16
#include					"screen-vram-full.h"
#define		TEXT_WIDTH	40
#define		TEXT_HEIGHT		25
#define		VRAM2SCREEN_DIFF		v2s_dif_C40x25_F_S_16
#define		VRAM2SCREEN_ALL			v2s_all_C40x25_F_S_16
#include					"screen-vram-full.h"
#define		TEXT_WIDTH	40
#define		TEXT_HEIGHT		20
#define		VRAM2SCREEN_DIFF		v2s_dif_C40x20_F_S_16
#define		VRAM2SCREEN_ALL			v2s_all_C40x20_F_S_16
#include					"screen-vram-full.h"
#undef	COLOR

#define MONO						/* 	 640x200 */
#define		TEXT_WIDTH	80
#define		TEXT_HEIGHT		25
#define		VRAM2SCREEN_DIFF		v2s_dif_M80x25_F_S_16
#define		VRAM2SCREEN_ALL			v2s_all_M80x25_F_S_16
#include					"screen-vram-full.h"
#define		TEXT_WIDTH	80
#define		TEXT_HEIGHT		20
#define		VRAM2SCREEN_DIFF		v2s_dif_M80x20_F_S_16
#define		VRAM2SCREEN_ALL			v2s_all_M80x20_F_S_16
#include					"screen-vram-full.h"
#define		TEXT_WIDTH	40
#define		TEXT_HEIGHT		25
#define		VRAM2SCREEN_DIFF		v2s_dif_M40x25_F_S_16
#define		VRAM2SCREEN_ALL			v2s_all_M40x25_F_S_16
#include					"screen-vram-full.h"
#define		TEXT_WIDTH	40
#define		TEXT_HEIGHT		20
#define		VRAM2SCREEN_DIFF		v2s_dif_M40x20_F_S_16
#define		VRAM2SCREEN_ALL			v2s_all_M40x20_F_S_16
#include					"screen-vram-full.h"
#undef	MONO

#define UNDISP						/* ɽ640x200 */
#define		TEXT_WIDTH	80
#define		TEXT_HEIGHT		25
#define		VRAM2SCREEN_DIFF		v2s_dif_U80x25_F_S_16
#define		VRAM2SCREEN_ALL			v2s_all_U80x25_F_S_16
#include					"screen-vram-full.h"
#define		TEXT_WIDTH	80
#define		TEXT_HEIGHT		20
#define		VRAM2SCREEN_DIFF		v2s_dif_U80x20_F_S_16
#define		VRAM2SCREEN_ALL			v2s_all_U80x20_F_S_16
#include					"screen-vram-full.h"
#define		TEXT_WIDTH	40
#define		TEXT_HEIGHT		25
#define		VRAM2SCREEN_DIFF		v2s_dif_U40x25_F_S_16
#define		VRAM2SCREEN_ALL			v2s_all_U40x25_F_S_16
#include					"screen-vram-full.h"
#define		TEXT_WIDTH	40
#define		TEXT_HEIGHT		20
#define		VRAM2SCREEN_DIFF		v2s_dif_U40x20_F_S_16
#define		VRAM2SCREEN_ALL			v2s_all_U40x20_F_S_16
#include					"screen-vram-full.h"
#undef	UNDISP

#undef	SKIPLINE
/*----------------------------------------------------------------------
 *			 200饤			󥿡졼
 *----------------------------------------------------------------------*/
#define INTERLACE

#define COLOR						/* 顼640x200 */
#define		TEXT_WIDTH	80
#define		TEXT_HEIGHT		25
#define		VRAM2SCREEN_DIFF		v2s_dif_C80x25_F_I_16
#define		VRAM2SCREEN_ALL			v2s_all_C80x25_F_I_16
#include					"screen-vram-full.h"
#define		TEXT_WIDTH	80
#define		TEXT_HEIGHT		20
#define		VRAM2SCREEN_DIFF		v2s_dif_C80x20_F_I_16
#define		VRAM2SCREEN_ALL			v2s_all_C80x20_F_I_16
#include					"screen-vram-full.h"
#define		TEXT_WIDTH	40
#define		TEXT_HEIGHT		25
#define		VRAM2SCREEN_DIFF		v2s_dif_C40x25_F_I_16
#define		VRAM2SCREEN_ALL			v2s_all_C40x25_F_I_16
#include					"screen-vram-full.h"
#define		TEXT_WIDTH	40
#define		TEXT_HEIGHT		20
#define		VRAM2SCREEN_DIFF		v2s_dif_C40x20_F_I_16
#define		VRAM2SCREEN_ALL			v2s_all_C40x20_F_I_16
#include					"screen-vram-full.h"
#undef	COLOR

#define MONO						/* 	 640x200 */
#define		TEXT_WIDTH	80
#define		TEXT_HEIGHT		25
#define		VRAM2SCREEN_DIFF		v2s_dif_M80x25_F_I_16
#define		VRAM2SCREEN_ALL			v2s_all_M80x25_F_I_16
#include					"screen-vram-full.h"
#define		TEXT_WIDTH	80
#define		TEXT_HEIGHT		20
#define		VRAM2SCREEN_DIFF		v2s_dif_M80x20_F_I_16
#define		VRAM2SCREEN_ALL			v2s_all_M80x20_F_I_16
#include					"screen-vram-full.h"
#define		TEXT_WIDTH	40
#define		TEXT_HEIGHT		25
#define		VRAM2SCREEN_DIFF		v2s_dif_M40x25_F_I_16
#define		VRAM2SCREEN_ALL			v2s_all_M40x25_F_I_16
#include					"screen-vram-full.h"
#define		TEXT_WIDTH	40
#define		TEXT_HEIGHT		20
#define		VRAM2SCREEN_DIFF		v2s_dif_M40x20_F_I_16
#define		VRAM2SCREEN_ALL			v2s_all_M40x20_F_I_16
#include					"screen-vram-full.h"
#undef	MONO

#define UNDISP						/* ɽ640x200 */
#define		TEXT_WIDTH	80
#define		TEXT_HEIGHT		25
#define		VRAM2SCREEN_DIFF		v2s_dif_U80x25_F_I_16
#define		VRAM2SCREEN_ALL			v2s_all_U80x25_F_I_16
#include					"screen-vram-full.h"
#define		TEXT_WIDTH	80
#define		TEXT_HEIGHT		20
#define		VRAM2SCREEN_DIFF		v2s_dif_U80x20_F_I_16
#define		VRAM2SCREEN_ALL			v2s_all_U80x20_F_I_16
#include					"screen-vram-full.h"
#define		TEXT_WIDTH	40
#define		TEXT_HEIGHT		25
#define		VRAM2SCREEN_DIFF		v2s_dif_U40x25_F_I_16
#define		VRAM2SCREEN_ALL			v2s_all_U40x25_F_I_16
#include					"screen-vram-full.h"
#define		TEXT_WIDTH	40
#define		TEXT_HEIGHT		20
#define		VRAM2SCREEN_DIFF		v2s_dif_U40x20_F_I_16
#define		VRAM2SCREEN_ALL			v2s_all_U40x20_F_I_16
#include					"screen-vram-full.h"
#undef	UNDISP

#undef	INTERLACE
/*----------------------------------------------------------------------
 *			 400饤			ɸ
 *----------------------------------------------------------------------*/
#define HIRESO						/* 	 640x400 */

#define		TEXT_WIDTH	80
#define		TEXT_HEIGHT		25
#define		VRAM2SCREEN_DIFF		v2s_dif_H80x25_F_N_16
#define		VRAM2SCREEN_ALL			v2s_all_H80x25_F_N_16
#include					"screen-vram-full.h"
#define		TEXT_WIDTH	80
#define		TEXT_HEIGHT		20
#define		VRAM2SCREEN_DIFF		v2s_dif_H80x20_F_N_16
#define		VRAM2SCREEN_ALL			v2s_all_H80x20_F_N_16
#include					"screen-vram-full.h"
#define		TEXT_WIDTH	40
#define		TEXT_HEIGHT		25
#define		VRAM2SCREEN_DIFF		v2s_dif_H40x25_F_N_16
#define		VRAM2SCREEN_ALL			v2s_all_H40x25_F_N_16
#include					"screen-vram-full.h"
#define		TEXT_WIDTH	40
#define		TEXT_HEIGHT		20
#define		VRAM2SCREEN_DIFF		v2s_dif_H40x20_F_N_16
#define		VRAM2SCREEN_ALL			v2s_all_H40x20_F_N_16
#include					"screen-vram-full.h"

#undef	HIRESO

/*===========================================================================
 * Ⱦʬ
 *===========================================================================*/

/*----------------------------------------------------------------------
 *			 200饤			ɸ
 *----------------------------------------------------------------------*/
#define NORMAL

#define COLOR						/* 顼640x200 */
#define		TEXT_WIDTH	80
#define		TEXT_HEIGHT		25
#define		VRAM2SCREEN_DIFF		v2s_dif_C80x25_H_N_16
#define		VRAM2SCREEN_ALL			v2s_all_C80x25_H_N_16
#include					"screen-vram-half.h"
#define		TEXT_WIDTH	80
#define		TEXT_HEIGHT		20
#define		VRAM2SCREEN_DIFF		v2s_dif_C80x20_H_N_16
#define		VRAM2SCREEN_ALL			v2s_all_C80x20_H_N_16
#include					"screen-vram-half.h"
#define		TEXT_WIDTH	40
#define		TEXT_HEIGHT		25
#define		VRAM2SCREEN_DIFF		v2s_dif_C40x25_H_N_16
#define		VRAM2SCREEN_ALL			v2s_all_C40x25_H_N_16
#include					"screen-vram-half.h"
#define		TEXT_WIDTH	40
#define		TEXT_HEIGHT		20
#define		VRAM2SCREEN_DIFF		v2s_dif_C40x20_H_N_16
#define		VRAM2SCREEN_ALL			v2s_all_C40x20_H_N_16
#include					"screen-vram-half.h"
#undef	COLOR

#define MONO						/* 	 640x200 */
#define		TEXT_WIDTH	80
#define		TEXT_HEIGHT		25
#define		VRAM2SCREEN_DIFF		v2s_dif_M80x25_H_N_16
#define		VRAM2SCREEN_ALL			v2s_all_M80x25_H_N_16
#include					"screen-vram-half.h"
#define		TEXT_WIDTH	80
#define		TEXT_HEIGHT		20
#define		VRAM2SCREEN_DIFF		v2s_dif_M80x20_H_N_16
#define		VRAM2SCREEN_ALL			v2s_all_M80x20_H_N_16
#include					"screen-vram-half.h"
#define		TEXT_WIDTH	40
#define		TEXT_HEIGHT		25
#define		VRAM2SCREEN_DIFF		v2s_dif_M40x25_H_N_16
#define		VRAM2SCREEN_ALL			v2s_all_M40x25_H_N_16
#include					"screen-vram-half.h"
#define		TEXT_WIDTH	40
#define		TEXT_HEIGHT		20
#define		VRAM2SCREEN_DIFF		v2s_dif_M40x20_H_N_16
#define		VRAM2SCREEN_ALL			v2s_all_M40x20_H_N_16
#include					"screen-vram-half.h"
#undef	MONO

#define UNDISP						/* ɽ640x200 */

#define		TEXT_WIDTH	80
#define		TEXT_HEIGHT		25
#define		VRAM2SCREEN_DIFF		v2s_dif_U80x25_H_N_16
#define		VRAM2SCREEN_ALL			v2s_all_U80x25_H_N_16
#include					"screen-vram-half.h"
#define		TEXT_WIDTH	80
#define		TEXT_HEIGHT		20
#define		VRAM2SCREEN_DIFF		v2s_dif_U80x20_H_N_16
#define		VRAM2SCREEN_ALL			v2s_all_U80x20_H_N_16
#include					"screen-vram-half.h"
#define		TEXT_WIDTH	40
#define		TEXT_HEIGHT		25
#define		VRAM2SCREEN_DIFF		v2s_dif_U40x25_H_N_16
#define		VRAM2SCREEN_ALL			v2s_all_U40x25_H_N_16
#include					"screen-vram-half.h"
#define		TEXT_WIDTH	40
#define		TEXT_HEIGHT		20
#define		VRAM2SCREEN_DIFF		v2s_dif_U40x20_H_N_16
#define		VRAM2SCREEN_ALL			v2s_all_U40x20_H_N_16
#include					"screen-vram-half.h"
#undef	UNDISP

#undef	NORMAL
/*----------------------------------------------------------------------
 *			 200饤			䴰
 *----------------------------------------------------------------------*/
#define INTERPOLATE

#define COLOR						/* 顼640x200 */
#define		TEXT_WIDTH	80
#define		TEXT_HEIGHT		25
#define		VRAM2SCREEN_DIFF		v2s_dif_C80x25_H_P_16
#define		VRAM2SCREEN_ALL			v2s_all_C80x25_H_P_16
#include					"screen-vram-half.h"
#define		TEXT_WIDTH	80
#define		TEXT_HEIGHT		20
#define		VRAM2SCREEN_DIFF		v2s_dif_C80x20_H_P_16
#define		VRAM2SCREEN_ALL			v2s_all_C80x20_H_P_16
#include					"screen-vram-half.h"
#define		TEXT_WIDTH	40
#define		TEXT_HEIGHT		25
#define		VRAM2SCREEN_DIFF		v2s_dif_C40x25_H_P_16
#define		VRAM2SCREEN_ALL			v2s_all_C40x25_H_P_16
#include					"screen-vram-half.h"
#define		TEXT_WIDTH	40
#define		TEXT_HEIGHT		20
#define		VRAM2SCREEN_DIFF		v2s_dif_C40x20_H_P_16
#define		VRAM2SCREEN_ALL			v2s_all_C40x20_H_P_16
#include					"screen-vram-half.h"
#undef	COLOR

#define MONO						/* 	 640x200 */
#define		TEXT_WIDTH	80
#define		TEXT_HEIGHT		25
#define		VRAM2SCREEN_DIFF		v2s_dif_M80x25_H_P_16
#define		VRAM2SCREEN_ALL			v2s_all_M80x25_H_P_16
#include					"screen-vram-half.h"
#define		TEXT_WIDTH	80
#define		TEXT_HEIGHT		20
#define		VRAM2SCREEN_DIFF		v2s_dif_M80x20_H_P_16
#define		VRAM2SCREEN_ALL			v2s_all_M80x20_H_P_16
#include					"screen-vram-half.h"
#define		TEXT_WIDTH	40
#define		TEXT_HEIGHT		25
#define		VRAM2SCREEN_DIFF		v2s_dif_M40x25_H_P_16
#define		VRAM2SCREEN_ALL			v2s_all_M40x25_H_P_16
#include					"screen-vram-half.h"
#define		TEXT_WIDTH	40
#define		TEXT_HEIGHT		20
#define		VRAM2SCREEN_DIFF		v2s_dif_M40x20_H_P_16
#define		VRAM2SCREEN_ALL			v2s_all_M40x20_H_P_16
#include					"screen-vram-half.h"
#undef	MONO

#define UNDISP						/* ɽ640x200 */
#define		TEXT_WIDTH	80
#define		TEXT_HEIGHT		25
#define		VRAM2SCREEN_DIFF		v2s_dif_U80x25_H_P_16
#define		VRAM2SCREEN_ALL			v2s_all_U80x25_H_P_16
#include					"screen-vram-half.h"
#define		TEXT_WIDTH	80
#define		TEXT_HEIGHT		20
#define		VRAM2SCREEN_DIFF		v2s_dif_U80x20_H_P_16
#define		VRAM2SCREEN_ALL			v2s_all_U80x20_H_P_16
#include					"screen-vram-half.h"
#define		TEXT_WIDTH	40
#define		TEXT_HEIGHT		25
#define		VRAM2SCREEN_DIFF		v2s_dif_U40x25_H_P_16
#define		VRAM2SCREEN_ALL			v2s_all_U40x25_H_P_16
#include					"screen-vram-half.h"
#define		TEXT_WIDTH	40
#define		TEXT_HEIGHT		20
#define		VRAM2SCREEN_DIFF		v2s_dif_U40x20_H_P_16
#define		VRAM2SCREEN_ALL			v2s_all_U40x20_H_P_16
#include					"screen-vram-half.h"
#undef	UNDISP

#undef	INTERPOLATE
/*----------------------------------------------------------------------
 *			 400饤			ɸ
 *----------------------------------------------------------------------*/
#define HIRESO						/* 	 640x400 */

#define		TEXT_WIDTH	80
#define		TEXT_HEIGHT		25
#define		VRAM2SCREEN_DIFF		v2s_dif_H80x25_H_N_16
#define		VRAM2SCREEN_ALL			v2s_all_H80x25_H_N_16
#include					"screen-vram-half.h"
#define		TEXT_WIDTH	80
#define		TEXT_HEIGHT		20
#define		VRAM2SCREEN_DIFF		v2s_dif_H80x20_H_N_16
#define		VRAM2SCREEN_ALL			v2s_all_H80x20_H_N_16
#include					"screen-vram-half.h"
#define		TEXT_WIDTH	40
#define		TEXT_HEIGHT		25
#define		VRAM2SCREEN_DIFF		v2s_dif_H40x25_H_N_16
#define		VRAM2SCREEN_ALL			v2s_all_H40x25_H_N_16
#include					"screen-vram-half.h"
#define		TEXT_WIDTH	40
#define		TEXT_HEIGHT		20
#define		VRAM2SCREEN_DIFF		v2s_dif_H40x20_H_N_16
#define		VRAM2SCREEN_ALL			v2s_all_H40x20_H_N_16
#include					"screen-vram-half.h"

#undef	HIRESO

/*===========================================================================
 * ܥ
 *===========================================================================*/
#ifdef	SUPPORT_DOUBLE
/*----------------------------------------------------------------------
 *			 200饤			ɸ
 *----------------------------------------------------------------------*/
#define NORMAL

#define COLOR						/* 顼640x200 */
#define		TEXT_WIDTH	80
#define		TEXT_HEIGHT		25
#define		VRAM2SCREEN_DIFF		v2s_dif_C80x25_D_N_16
#define		VRAM2SCREEN_ALL			v2s_all_C80x25_D_N_16
#include					"screen-vram-double.h"
#define		TEXT_WIDTH	80
#define		TEXT_HEIGHT		20
#define		VRAM2SCREEN_DIFF		v2s_dif_C80x20_D_N_16
#define		VRAM2SCREEN_ALL			v2s_all_C80x20_D_N_16
#include					"screen-vram-double.h"
#define		TEXT_WIDTH	40
#define		TEXT_HEIGHT		25
#define		VRAM2SCREEN_DIFF		v2s_dif_C40x25_D_N_16
#define		VRAM2SCREEN_ALL			v2s_all_C40x25_D_N_16
#include					"screen-vram-double.h"
#define		TEXT_WIDTH	40
#define		TEXT_HEIGHT		20
#define		VRAM2SCREEN_DIFF		v2s_dif_C40x20_D_N_16
#define		VRAM2SCREEN_ALL			v2s_all_C40x20_D_N_16
#include					"screen-vram-double.h"
#undef	COLOR

#define MONO						/* 	 640x200 */
#define		TEXT_WIDTH	80
#define		TEXT_HEIGHT		25
#define		VRAM2SCREEN_DIFF		v2s_dif_M80x25_D_N_16
#define		VRAM2SCREEN_ALL			v2s_all_M80x25_D_N_16
#include					"screen-vram-double.h"
#define		TEXT_WIDTH	80
#define		TEXT_HEIGHT		20
#define		VRAM2SCREEN_DIFF		v2s_dif_M80x20_D_N_16
#define		VRAM2SCREEN_ALL			v2s_all_M80x20_D_N_16
#include					"screen-vram-double.h"
#define		TEXT_WIDTH	40
#define		TEXT_HEIGHT		25
#define		VRAM2SCREEN_DIFF		v2s_dif_M40x25_D_N_16
#define		VRAM2SCREEN_ALL			v2s_all_M40x25_D_N_16
#include					"screen-vram-double.h"
#define		TEXT_WIDTH	40
#define		TEXT_HEIGHT		20
#define		VRAM2SCREEN_DIFF		v2s_dif_M40x20_D_N_16
#define		VRAM2SCREEN_ALL			v2s_all_M40x20_D_N_16
#include					"screen-vram-double.h"
#undef	MONO

#define UNDISP						/* ɽ640x200 */
#define		TEXT_WIDTH	80
#define		TEXT_HEIGHT		25
#define		VRAM2SCREEN_DIFF		v2s_dif_U80x25_D_N_16
#define		VRAM2SCREEN_ALL			v2s_all_U80x25_D_N_16
#include					"screen-vram-double.h"
#define		TEXT_WIDTH	80
#define		TEXT_HEIGHT		20
#define		VRAM2SCREEN_DIFF		v2s_dif_U80x20_D_N_16
#define		VRAM2SCREEN_ALL			v2s_all_U80x20_D_N_16
#include					"screen-vram-double.h"
#define		TEXT_WIDTH	40
#define		TEXT_HEIGHT		25
#define		VRAM2SCREEN_DIFF		v2s_dif_U40x25_D_N_16
#define		VRAM2SCREEN_ALL			v2s_all_U40x25_D_N_16
#include					"screen-vram-double.h"
#define		TEXT_WIDTH	40
#define		TEXT_HEIGHT		20
#define		VRAM2SCREEN_DIFF		v2s_dif_U40x20_D_N_16
#define		VRAM2SCREEN_ALL			v2s_all_U40x20_D_N_16
#include					"screen-vram-double.h"
#undef	UNDISP

#undef	NORMAL
/*----------------------------------------------------------------------
 *			 200饤			饤󥹥å
 *----------------------------------------------------------------------*/
#define SKIPLINE

#define COLOR						/* 顼640x200 */
#define		TEXT_WIDTH	80
#define		TEXT_HEIGHT		25
#define		VRAM2SCREEN_DIFF		v2s_dif_C80x25_D_S_16
#define		VRAM2SCREEN_ALL			v2s_all_C80x25_D_S_16
#include					"screen-vram-double.h"
#define		TEXT_WIDTH	80
#define		TEXT_HEIGHT		20
#define		VRAM2SCREEN_DIFF		v2s_dif_C80x20_D_S_16
#define		VRAM2SCREEN_ALL			v2s_all_C80x20_D_S_16
#include					"screen-vram-double.h"
#define		TEXT_WIDTH	40
#define		TEXT_HEIGHT		25
#define		VRAM2SCREEN_DIFF		v2s_dif_C40x25_D_S_16
#define		VRAM2SCREEN_ALL			v2s_all_C40x25_D_S_16
#include					"screen-vram-double.h"
#define		TEXT_WIDTH	40
#define		TEXT_HEIGHT		20
#define		VRAM2SCREEN_DIFF		v2s_dif_C40x20_D_S_16
#define		VRAM2SCREEN_ALL			v2s_all_C40x20_D_S_16
#include					"screen-vram-double.h"
#undef	COLOR

#define MONO						/* 	 640x200 */
#define		TEXT_WIDTH	80
#define		TEXT_HEIGHT		25
#define		VRAM2SCREEN_DIFF		v2s_dif_M80x25_D_S_16
#define		VRAM2SCREEN_ALL			v2s_all_M80x25_D_S_16
#include					"screen-vram-double.h"
#define		TEXT_WIDTH	80
#define		TEXT_HEIGHT		20
#define		VRAM2SCREEN_DIFF		v2s_dif_M80x20_D_S_16
#define		VRAM2SCREEN_ALL			v2s_all_M80x20_D_S_16
#include					"screen-vram-double.h"
#define		TEXT_WIDTH	40
#define		TEXT_HEIGHT		25
#define		VRAM2SCREEN_DIFF		v2s_dif_M40x25_D_S_16
#define		VRAM2SCREEN_ALL			v2s_all_M40x25_D_S_16
#include					"screen-vram-double.h"
#define		TEXT_WIDTH	40
#define		TEXT_HEIGHT		20
#define		VRAM2SCREEN_DIFF		v2s_dif_M40x20_D_S_16
#define		VRAM2SCREEN_ALL			v2s_all_M40x20_D_S_16
#include					"screen-vram-double.h"
#undef	MONO

#define UNDISP						/* ɽ640x200 */
#define		TEXT_WIDTH	80
#define		TEXT_HEIGHT		25
#define		VRAM2SCREEN_DIFF		v2s_dif_U80x25_D_S_16
#define		VRAM2SCREEN_ALL			v2s_all_U80x25_D_S_16
#include					"screen-vram-double.h"
#define		TEXT_WIDTH	80
#define		TEXT_HEIGHT		20
#define		VRAM2SCREEN_DIFF		v2s_dif_U80x20_D_S_16
#define		VRAM2SCREEN_ALL			v2s_all_U80x20_D_S_16
#include					"screen-vram-double.h"
#define		TEXT_WIDTH	40
#define		TEXT_HEIGHT		25
#define		VRAM2SCREEN_DIFF		v2s_dif_U40x25_D_S_16
#define		VRAM2SCREEN_ALL			v2s_all_U40x25_D_S_16
#include					"screen-vram-double.h"
#define		TEXT_WIDTH	40
#define		TEXT_HEIGHT		20
#define		VRAM2SCREEN_DIFF		v2s_dif_U40x20_D_S_16
#define		VRAM2SCREEN_ALL			v2s_all_U40x20_D_S_16
#include					"screen-vram-double.h"
#undef	UNDISP

#undef	SKIPLINE
/*----------------------------------------------------------------------
 *			 200饤			󥿡졼
 *----------------------------------------------------------------------*/
#define INTERLACE

#define COLOR						/* 顼640x200 */
#define		TEXT_WIDTH	80
#define		TEXT_HEIGHT		25
#define		VRAM2SCREEN_DIFF		v2s_dif_C80x25_D_I_16
#define		VRAM2SCREEN_ALL			v2s_all_C80x25_D_I_16
#include					"screen-vram-double.h"
#define		TEXT_WIDTH	80
#define		TEXT_HEIGHT		20
#define		VRAM2SCREEN_DIFF		v2s_dif_C80x20_D_I_16
#define		VRAM2SCREEN_ALL			v2s_all_C80x20_D_I_16
#include					"screen-vram-double.h"
#define		TEXT_WIDTH	40
#define		TEXT_HEIGHT		25
#define		VRAM2SCREEN_DIFF		v2s_dif_C40x25_D_I_16
#define		VRAM2SCREEN_ALL			v2s_all_C40x25_D_I_16
#include					"screen-vram-double.h"
#define		TEXT_WIDTH	40
#define		TEXT_HEIGHT		20
#define		VRAM2SCREEN_DIFF		v2s_dif_C40x20_D_I_16
#define		VRAM2SCREEN_ALL			v2s_all_C40x20_D_I_16
#include					"screen-vram-double.h"
#undef	COLOR

#define MONO						/* 	 640x200 */
#define		TEXT_WIDTH	80
#define		TEXT_HEIGHT		25
#define		VRAM2SCREEN_DIFF		v2s_dif_M80x25_D_I_16
#define		VRAM2SCREEN_ALL			v2s_all_M80x25_D_I_16
#include					"screen-vram-double.h"
#define		TEXT_WIDTH	80
#define		TEXT_HEIGHT		20
#define		VRAM2SCREEN_DIFF		v2s_dif_M80x20_D_I_16
#define		VRAM2SCREEN_ALL			v2s_all_M80x20_D_I_16
#include					"screen-vram-double.h"
#define		TEXT_WIDTH	40
#define		TEXT_HEIGHT		25
#define		VRAM2SCREEN_DIFF		v2s_dif_M40x25_D_I_16
#define		VRAM2SCREEN_ALL			v2s_all_M40x25_D_I_16
#include					"screen-vram-double.h"
#define		TEXT_WIDTH	40
#define		TEXT_HEIGHT		20
#define		VRAM2SCREEN_DIFF		v2s_dif_M40x20_D_I_16
#define		VRAM2SCREEN_ALL			v2s_all_M40x20_D_I_16
#include					"screen-vram-double.h"
#undef	MONO

#define UNDISP						/* ɽ640x200 */
#define		TEXT_WIDTH	80
#define		TEXT_HEIGHT		25
#define		VRAM2SCREEN_DIFF		v2s_dif_U80x25_D_I_16
#define		VRAM2SCREEN_ALL			v2s_all_U80x25_D_I_16
#include					"screen-vram-double.h"
#define		TEXT_WIDTH	80
#define		TEXT_HEIGHT		20
#define		VRAM2SCREEN_DIFF		v2s_dif_U80x20_D_I_16
#define		VRAM2SCREEN_ALL			v2s_all_U80x20_D_I_16
#include					"screen-vram-double.h"
#define		TEXT_WIDTH	40
#define		TEXT_HEIGHT		25
#define		VRAM2SCREEN_DIFF		v2s_dif_U40x25_D_I_16
#define		VRAM2SCREEN_ALL			v2s_all_U40x25_D_I_16
#include					"screen-vram-double.h"
#define		TEXT_WIDTH	40
#define		TEXT_HEIGHT		20
#define		VRAM2SCREEN_DIFF		v2s_dif_U40x20_D_I_16
#define		VRAM2SCREEN_ALL			v2s_all_U40x20_D_I_16
#include					"screen-vram-double.h"
#undef	UNDISP

#undef	INTERLACE
/*----------------------------------------------------------------------
 *			 400饤			ɸ
 *----------------------------------------------------------------------*/
#define HIRESO						/* 	 640x400 */

#define		TEXT_WIDTH	80
#define		TEXT_HEIGHT		25
#define		VRAM2SCREEN_DIFF		v2s_dif_H80x25_D_N_16
#define		VRAM2SCREEN_ALL			v2s_all_H80x25_D_N_16
#include					"screen-vram-double.h"
#define		TEXT_WIDTH	80
#define		TEXT_HEIGHT		20
#define		VRAM2SCREEN_DIFF		v2s_dif_H80x20_D_N_16
#define		VRAM2SCREEN_ALL			v2s_all_H80x20_D_N_16
#include					"screen-vram-double.h"
#define		TEXT_WIDTH	40
#define		TEXT_HEIGHT		25
#define		VRAM2SCREEN_DIFF		v2s_dif_H40x25_D_N_16
#define		VRAM2SCREEN_ALL			v2s_all_H40x25_D_N_16
#include					"screen-vram-double.h"
#define		TEXT_WIDTH	40
#define		TEXT_HEIGHT		20
#define		VRAM2SCREEN_DIFF		v2s_dif_H40x20_D_N_16
#define		VRAM2SCREEN_ALL			v2s_all_H40x20_D_N_16
#include					"screen-vram-double.h"
#undef	HIRESO

#endif	/* SUPPORT_DOUBLE */


#define	DIRECT
/*===========================================================================
 * ܥ
 *===========================================================================*/

/*----------------------------------------------------------------------
 *			 200饤			ɸ
 *----------------------------------------------------------------------*/
#define NORMAL

#define COLOR						/* 顼640x200 */
#define		TEXT_WIDTH	80
#define		TEXT_HEIGHT		25
#define		VRAM2SCREEN_DIFF		v2s_dif_C80x25_F_N_16_d
#define		VRAM2SCREEN_ALL			v2s_all_C80x25_F_N_16_d
#include					"screen-vram-full.h"
#define		TEXT_WIDTH	80
#define		TEXT_HEIGHT		20
#define		VRAM2SCREEN_DIFF		v2s_dif_C80x20_F_N_16_d
#define		VRAM2SCREEN_ALL			v2s_all_C80x20_F_N_16_d
#include					"screen-vram-full.h"
#define		TEXT_WIDTH	40
#define		TEXT_HEIGHT		25
#define		VRAM2SCREEN_DIFF		v2s_dif_C40x25_F_N_16_d
#define		VRAM2SCREEN_ALL			v2s_all_C40x25_F_N_16_d
#include					"screen-vram-full.h"
#define		TEXT_WIDTH	40
#define		TEXT_HEIGHT		20
#define		VRAM2SCREEN_DIFF		v2s_dif_C40x20_F_N_16_d
#define		VRAM2SCREEN_ALL			v2s_all_C40x20_F_N_16_d
#include					"screen-vram-full.h"
#undef	COLOR

#define MONO						/* 	 640x200 */
#define		TEXT_WIDTH	80
#define		TEXT_HEIGHT		25
#define		VRAM2SCREEN_DIFF		v2s_dif_M80x25_F_N_16_d
#define		VRAM2SCREEN_ALL			v2s_all_M80x25_F_N_16_d
#include					"screen-vram-full.h"
#define		TEXT_WIDTH	80
#define		TEXT_HEIGHT		20
#define		VRAM2SCREEN_DIFF		v2s_dif_M80x20_F_N_16_d
#define		VRAM2SCREEN_ALL			v2s_all_M80x20_F_N_16_d
#include					"screen-vram-full.h"
#define		TEXT_WIDTH	40
#define		TEXT_HEIGHT		25
#define		VRAM2SCREEN_DIFF		v2s_dif_M40x25_F_N_16_d
#define		VRAM2SCREEN_ALL			v2s_all_M40x25_F_N_16_d
#include					"screen-vram-full.h"
#define		TEXT_WIDTH	40
#define		TEXT_HEIGHT		20
#define		VRAM2SCREEN_DIFF		v2s_dif_M40x20_F_N_16_d
#define		VRAM2SCREEN_ALL			v2s_all_M40x20_F_N_16_d
#include					"screen-vram-full.h"
#undef	MONO

#define UNDISP						/* ɽ640x200 */
#define		TEXT_WIDTH	80
#define		TEXT_HEIGHT		25
#define		VRAM2SCREEN_DIFF		v2s_dif_U80x25_F_N_16_d
#define		VRAM2SCREEN_ALL			v2s_all_U80x25_F_N_16_d
#include					"screen-vram-full.h"
#define		TEXT_WIDTH	80
#define		TEXT_HEIGHT		20
#define		VRAM2SCREEN_DIFF		v2s_dif_U80x20_F_N_16_d
#define		VRAM2SCREEN_ALL			v2s_all_U80x20_F_N_16_d
#include					"screen-vram-full.h"
#define		TEXT_WIDTH	40
#define		TEXT_HEIGHT		25
#define		VRAM2SCREEN_DIFF		v2s_dif_U40x25_F_N_16_d
#define		VRAM2SCREEN_ALL			v2s_all_U40x25_F_N_16_d
#include					"screen-vram-full.h"
#define		TEXT_WIDTH	40
#define		TEXT_HEIGHT		20
#define		VRAM2SCREEN_DIFF		v2s_dif_U40x20_F_N_16_d
#define		VRAM2SCREEN_ALL			v2s_all_U40x20_F_N_16_d
#include					"screen-vram-full.h"
#undef	UNDISP

#undef	NORMAL

/*===========================================================================
 * ܥ
 *===========================================================================*/
#ifdef	SUPPORT_DOUBLE
/*----------------------------------------------------------------------
 *			 200饤			ɸ
 *----------------------------------------------------------------------*/
#define NORMAL

#define COLOR						/* 顼640x200 */
#define		TEXT_WIDTH	80
#define		TEXT_HEIGHT		25
#define		VRAM2SCREEN_DIFF		v2s_dif_C80x25_D_N_16_d
#define		VRAM2SCREEN_ALL			v2s_all_C80x25_D_N_16_d
#include					"screen-vram-double.h"
#define		TEXT_WIDTH	80
#define		TEXT_HEIGHT		20
#define		VRAM2SCREEN_DIFF		v2s_dif_C80x20_D_N_16_d
#define		VRAM2SCREEN_ALL			v2s_all_C80x20_D_N_16_d
#include					"screen-vram-double.h"
#define		TEXT_WIDTH	40
#define		TEXT_HEIGHT		25
#define		VRAM2SCREEN_DIFF		v2s_dif_C40x25_D_N_16_d
#define		VRAM2SCREEN_ALL			v2s_all_C40x25_D_N_16_d
#include					"screen-vram-double.h"
#define		TEXT_WIDTH	40
#define		TEXT_HEIGHT		20
#define		VRAM2SCREEN_DIFF		v2s_dif_C40x20_D_N_16_d
#define		VRAM2SCREEN_ALL			v2s_all_C40x20_D_N_16_d
#include					"screen-vram-double.h"
#undef	COLOR

#define MONO						/* 	 640x200 */
#define		TEXT_WIDTH	80
#define		TEXT_HEIGHT		25
#define		VRAM2SCREEN_DIFF		v2s_dif_M80x25_D_N_16_d
#define		VRAM2SCREEN_ALL			v2s_all_M80x25_D_N_16_d
#include					"screen-vram-double.h"
#define		TEXT_WIDTH	80
#define		TEXT_HEIGHT		20
#define		VRAM2SCREEN_DIFF		v2s_dif_M80x20_D_N_16_d
#define		VRAM2SCREEN_ALL			v2s_all_M80x20_D_N_16_d
#include					"screen-vram-double.h"
#define		TEXT_WIDTH	40
#define		TEXT_HEIGHT		25
#define		VRAM2SCREEN_DIFF		v2s_dif_M40x25_D_N_16_d
#define		VRAM2SCREEN_ALL			v2s_all_M40x25_D_N_16_d
#include					"screen-vram-double.h"
#define		TEXT_WIDTH	40
#define		TEXT_HEIGHT		20
#define		VRAM2SCREEN_DIFF		v2s_dif_M40x20_D_N_16_d
#define		VRAM2SCREEN_ALL			v2s_all_M40x20_D_N_16_d
#include					"screen-vram-double.h"
#undef	MONO

#define UNDISP						/* ɽ640x200 */
#define		TEXT_WIDTH	80
#define		TEXT_HEIGHT		25
#define		VRAM2SCREEN_DIFF		v2s_dif_U80x25_D_N_16_d
#define		VRAM2SCREEN_ALL			v2s_all_U80x25_D_N_16_d
#include					"screen-vram-double.h"
#define		TEXT_WIDTH	80
#define		TEXT_HEIGHT		20
#define		VRAM2SCREEN_DIFF		v2s_dif_U80x20_D_N_16_d
#define		VRAM2SCREEN_ALL			v2s_all_U80x20_D_N_16_d
#include					"screen-vram-double.h"
#define		TEXT_WIDTH	40
#define		TEXT_HEIGHT		25
#define		VRAM2SCREEN_DIFF		v2s_dif_U40x25_D_N_16_d
#define		VRAM2SCREEN_ALL			v2s_all_U40x25_D_N_16_d
#include					"screen-vram-double.h"
#define		TEXT_WIDTH	40
#define		TEXT_HEIGHT		20
#define		VRAM2SCREEN_DIFF		v2s_dif_U40x20_D_N_16_d
#define		VRAM2SCREEN_ALL			v2s_all_U40x20_D_N_16_d
#include					"screen-vram-double.h"
#undef	UNDISP

#undef	NORMAL
/*----------------------------------------------------------------------
 *			 200饤			饤󥹥å
 *----------------------------------------------------------------------*/
#define SKIPLINE

#define COLOR						/* 顼640x200 */
#define		TEXT_WIDTH	80
#define		TEXT_HEIGHT		25
#define		VRAM2SCREEN_DIFF		v2s_dif_C80x25_D_S_16_d
#define		VRAM2SCREEN_ALL			v2s_all_C80x25_D_S_16_d
#include					"screen-vram-double.h"
#define		TEXT_WIDTH	80
#define		TEXT_HEIGHT		20
#define		VRAM2SCREEN_DIFF		v2s_dif_C80x20_D_S_16_d
#define		VRAM2SCREEN_ALL			v2s_all_C80x20_D_S_16_d
#include					"screen-vram-double.h"
#define		TEXT_WIDTH	40
#define		TEXT_HEIGHT		25
#define		VRAM2SCREEN_DIFF		v2s_dif_C40x25_D_S_16_d
#define		VRAM2SCREEN_ALL			v2s_all_C40x25_D_S_16_d
#include					"screen-vram-double.h"
#define		TEXT_WIDTH	40
#define		TEXT_HEIGHT		20
#define		VRAM2SCREEN_DIFF		v2s_dif_C40x20_D_S_16_d
#define		VRAM2SCREEN_ALL			v2s_all_C40x20_D_S_16_d
#include					"screen-vram-double.h"
#undef	COLOR

#define MONO						/* 	 640x200 */
#define		TEXT_WIDTH	80
#define		TEXT_HEIGHT		25
#define		VRAM2SCREEN_DIFF		v2s_dif_M80x25_D_S_16_d
#define		VRAM2SCREEN_ALL			v2s_all_M80x25_D_S_16_d
#include					"screen-vram-double.h"
#define		TEXT_WIDTH	80
#define		TEXT_HEIGHT		20
#define		VRAM2SCREEN_DIFF		v2s_dif_M80x20_D_S_16_d
#define		VRAM2SCREEN_ALL			v2s_all_M80x20_D_S_16_d
#include					"screen-vram-double.h"
#define		TEXT_WIDTH	40
#define		TEXT_HEIGHT		25
#define		VRAM2SCREEN_DIFF		v2s_dif_M40x25_D_S_16_d
#define		VRAM2SCREEN_ALL			v2s_all_M40x25_D_S_16_d
#include					"screen-vram-double.h"
#define		TEXT_WIDTH	40
#define		TEXT_HEIGHT		20
#define		VRAM2SCREEN_DIFF		v2s_dif_M40x20_D_S_16_d
#define		VRAM2SCREEN_ALL			v2s_all_M40x20_D_S_16_d
#include					"screen-vram-double.h"
#undef	MONO

#define UNDISP						/* ɽ640x200 */
#define		TEXT_WIDTH	80
#define		TEXT_HEIGHT		25
#define		VRAM2SCREEN_DIFF		v2s_dif_U80x25_D_S_16_d
#define		VRAM2SCREEN_ALL			v2s_all_U80x25_D_S_16_d
#include					"screen-vram-double.h"
#define		TEXT_WIDTH	80
#define		TEXT_HEIGHT		20
#define		VRAM2SCREEN_DIFF		v2s_dif_U80x20_D_S_16_d
#define		VRAM2SCREEN_ALL			v2s_all_U80x20_D_S_16_d
#include					"screen-vram-double.h"
#define		TEXT_WIDTH	40
#define		TEXT_HEIGHT		25
#define		VRAM2SCREEN_DIFF		v2s_dif_U40x25_D_S_16_d
#define		VRAM2SCREEN_ALL			v2s_all_U40x25_D_S_16_d
#include					"screen-vram-double.h"
#define		TEXT_WIDTH	40
#define		TEXT_HEIGHT		20
#define		VRAM2SCREEN_DIFF		v2s_dif_U40x20_D_S_16_d
#define		VRAM2SCREEN_ALL			v2s_all_U40x20_D_S_16_d
#include					"screen-vram-double.h"
#undef	UNDISP

#undef	SKIPLINE
/*----------------------------------------------------------------------
 *			 200饤			󥿡졼
 *----------------------------------------------------------------------*/
#define INTERLACE

#define COLOR						/* 顼640x200 */
#define		TEXT_WIDTH	80
#define		TEXT_HEIGHT		25
#define		VRAM2SCREEN_DIFF		v2s_dif_C80x25_D_I_16_d
#define		VRAM2SCREEN_ALL			v2s_all_C80x25_D_I_16_d
#include					"screen-vram-double.h"
#define		TEXT_WIDTH	80
#define		TEXT_HEIGHT		20
#define		VRAM2SCREEN_DIFF		v2s_dif_C80x20_D_I_16_d
#define		VRAM2SCREEN_ALL			v2s_all_C80x20_D_I_16_d
#include					"screen-vram-double.h"
#define		TEXT_WIDTH	40
#define		TEXT_HEIGHT		25
#define		VRAM2SCREEN_DIFF		v2s_dif_C40x25_D_I_16_d
#define		VRAM2SCREEN_ALL			v2s_all_C40x25_D_I_16_d
#include					"screen-vram-double.h"
#define		TEXT_WIDTH	40
#define		TEXT_HEIGHT		20
#define		VRAM2SCREEN_DIFF		v2s_dif_C40x20_D_I_16_d
#define		VRAM2SCREEN_ALL			v2s_all_C40x20_D_I_16_d
#include					"screen-vram-double.h"
#undef	COLOR

#define MONO						/* 	 640x200 */
#define		TEXT_WIDTH	80
#define		TEXT_HEIGHT		25
#define		VRAM2SCREEN_DIFF		v2s_dif_M80x25_D_I_16_d
#define		VRAM2SCREEN_ALL			v2s_all_M80x25_D_I_16_d
#include					"screen-vram-double.h"
#define		TEXT_WIDTH	80
#define		TEXT_HEIGHT		20
#define		VRAM2SCREEN_DIFF		v2s_dif_M80x20_D_I_16_d
#define		VRAM2SCREEN_ALL			v2s_all_M80x20_D_I_16_d
#include					"screen-vram-double.h"
#define		TEXT_WIDTH	40
#define		TEXT_HEIGHT		25
#define		VRAM2SCREEN_DIFF		v2s_dif_M40x25_D_I_16_d
#define		VRAM2SCREEN_ALL			v2s_all_M40x25_D_I_16_d
#include					"screen-vram-double.h"
#define		TEXT_WIDTH	40
#define		TEXT_HEIGHT		20
#define		VRAM2SCREEN_DIFF		v2s_dif_M40x20_D_I_16_d
#define		VRAM2SCREEN_ALL			v2s_all_M40x20_D_I_16_d
#include					"screen-vram-double.h"
#undef	MONO

#define UNDISP						/* ɽ640x200 */
#define		TEXT_WIDTH	80
#define		TEXT_HEIGHT		25
#define		VRAM2SCREEN_DIFF		v2s_dif_U80x25_D_I_16_d
#define		VRAM2SCREEN_ALL			v2s_all_U80x25_D_I_16_d
#include					"screen-vram-double.h"
#define		TEXT_WIDTH	80
#define		TEXT_HEIGHT		20
#define		VRAM2SCREEN_DIFF		v2s_dif_U80x20_D_I_16_d
#define		VRAM2SCREEN_ALL			v2s_all_U80x20_D_I_16_d
#include					"screen-vram-double.h"
#define		TEXT_WIDTH	40
#define		TEXT_HEIGHT		25
#define		VRAM2SCREEN_DIFF		v2s_dif_U40x25_D_I_16_d
#define		VRAM2SCREEN_ALL			v2s_all_U40x25_D_I_16_d
#include					"screen-vram-double.h"
#define		TEXT_WIDTH	40
#define		TEXT_HEIGHT		20
#define		VRAM2SCREEN_DIFF		v2s_dif_U40x20_D_I_16_d
#define		VRAM2SCREEN_ALL			v2s_all_U40x20_D_I_16_d
#include					"screen-vram-double.h"
#undef	UNDISP

#undef	INTERLACE
/*----------------------------------------------------------------------
 *			 400饤			ɸ
 *----------------------------------------------------------------------*/
#define HIRESO						/* 	 640x400 */

#define		TEXT_WIDTH	80
#define		TEXT_HEIGHT		25
#define		VRAM2SCREEN_DIFF		v2s_dif_H80x25_D_N_16_d
#define		VRAM2SCREEN_ALL			v2s_all_H80x25_D_N_16_d
#include					"screen-vram-double.h"
#define		TEXT_WIDTH	80
#define		TEXT_HEIGHT		20
#define		VRAM2SCREEN_DIFF		v2s_dif_H80x20_D_N_16_d
#define		VRAM2SCREEN_ALL			v2s_all_H80x20_D_N_16_d
#include					"screen-vram-double.h"
#define		TEXT_WIDTH	40
#define		TEXT_HEIGHT		25
#define		VRAM2SCREEN_DIFF		v2s_dif_H40x25_D_N_16_d
#define		VRAM2SCREEN_ALL			v2s_all_H40x25_D_N_16_d
#include					"screen-vram-double.h"
#define		TEXT_WIDTH	40
#define		TEXT_HEIGHT		20
#define		VRAM2SCREEN_DIFF		v2s_dif_H40x20_D_N_16_d
#define		VRAM2SCREEN_ALL			v2s_all_H40x20_D_N_16_d
#include					"screen-vram-double.h"
#undef	HIRESO

#endif	/* SUPPORT_DOUBLE */
#undef	DIRECT


/*===========================================================================
 * ̾õ
 *===========================================================================*/

#define		SCREEN_BUF_INIT			screen_buf_init_16
#include					"screen-vram-clear.h"


/*===========================================================================
 * ˥塼
 *===========================================================================*/

#define		MENU2SCREEN			menu2screen_F_N_16
#include					"screen-menu-full.h"

#define		MENU2SCREEN			menu2screen_H_N_16
#include					"screen-menu-half.h"

#define		MENU2SCREEN			menu2screen_H_P_16
#include					"screen-menu-half-p.h"

#ifdef	SUPPORT_DOUBLE
#define		MENU2SCREEN			menu2screen_D_N_16
#include					"screen-menu-double.h"
#endif


/*===========================================================================
 * ơ
 *===========================================================================*/

#define		STATUS2SCREEN			status2screen_16
#define		STATUS_BUF_INIT			status_buf_init_16
#define		STATUS_BUF_CLEAR		status_buf_clear_16
#include					"screen-status.h"


#undef	TYPE		/* bit16 */












/* ========================================================================= */
/* ܥ - ɸ */

int (*vram2screen_list_F_N_16[4][4][2])(void) =
{
    {
	{ v2s_dif_C80x25_F_N_16, v2s_all_C80x25_F_N_16 },
	{ v2s_dif_C80x20_F_N_16, v2s_all_C80x20_F_N_16 },
	{ v2s_dif_C40x25_F_N_16, v2s_all_C40x25_F_N_16 },
	{ v2s_dif_C40x20_F_N_16, v2s_all_C40x20_F_N_16 },
    },
    {
	{ v2s_dif_M80x25_F_N_16, v2s_all_M80x25_F_N_16 },
	{ v2s_dif_M80x20_F_N_16, v2s_all_M80x20_F_N_16 },
	{ v2s_dif_M40x25_F_N_16, v2s_all_M40x25_F_N_16 },
	{ v2s_dif_M40x20_F_N_16, v2s_all_M40x20_F_N_16 },
    },
    {
	{ v2s_dif_U80x25_F_N_16, v2s_all_U80x25_F_N_16 },
	{ v2s_dif_U80x20_F_N_16, v2s_all_U80x20_F_N_16 },
	{ v2s_dif_U40x25_F_N_16, v2s_all_U40x25_F_N_16 },
	{ v2s_dif_U40x20_F_N_16, v2s_all_U40x20_F_N_16 },
    },
    {
	{ v2s_dif_H80x25_F_N_16, v2s_all_H80x25_F_N_16 },
	{ v2s_dif_H80x20_F_N_16, v2s_all_H80x20_F_N_16 },
	{ v2s_dif_H40x25_F_N_16, v2s_all_H40x25_F_N_16 },
	{ v2s_dif_H40x20_F_N_16, v2s_all_H40x20_F_N_16 },
    },
};

/* ܥ - åץ饤 */

int (*vram2screen_list_F_S_16[4][4][2])(void) =
{
    {
	{ v2s_dif_C80x25_F_S_16, v2s_all_C80x25_F_S_16 },
	{ v2s_dif_C80x20_F_S_16, v2s_all_C80x20_F_S_16 },
	{ v2s_dif_C40x25_F_S_16, v2s_all_C40x25_F_S_16 },
	{ v2s_dif_C40x20_F_S_16, v2s_all_C40x20_F_S_16 },
    },
    {
	{ v2s_dif_M80x25_F_S_16, v2s_all_M80x25_F_S_16 },
	{ v2s_dif_M80x20_F_S_16, v2s_all_M80x20_F_S_16 },
	{ v2s_dif_M40x25_F_S_16, v2s_all_M40x25_F_S_16 },
	{ v2s_dif_M40x20_F_S_16, v2s_all_M40x20_F_S_16 },
    },
    {
	{ v2s_dif_U80x25_F_S_16, v2s_all_U80x25_F_S_16 },
	{ v2s_dif_U80x20_F_S_16, v2s_all_U80x20_F_S_16 },
	{ v2s_dif_U40x25_F_S_16, v2s_all_U40x25_F_S_16 },
	{ v2s_dif_U40x20_F_S_16, v2s_all_U40x20_F_S_16 },
    },
    {
	{ v2s_dif_H80x25_F_N_16, v2s_all_H80x25_F_N_16 },
	{ v2s_dif_H80x20_F_N_16, v2s_all_H80x20_F_N_16 },
	{ v2s_dif_H40x25_F_N_16, v2s_all_H40x25_F_N_16 },
	{ v2s_dif_H40x20_F_N_16, v2s_all_H40x20_F_N_16 },
    },
};

/* ܥ - 󥿡졼 */

int (*vram2screen_list_F_I_16[4][4][2])(void) =
{
    {
	{ v2s_dif_C80x25_F_I_16, v2s_all_C80x25_F_I_16 },
	{ v2s_dif_C80x20_F_I_16, v2s_all_C80x20_F_I_16 },
	{ v2s_dif_C40x25_F_I_16, v2s_all_C40x25_F_I_16 },
	{ v2s_dif_C40x20_F_I_16, v2s_all_C40x20_F_I_16 },
    },
    {
	{ v2s_dif_M80x25_F_I_16, v2s_all_M80x25_F_I_16 },
	{ v2s_dif_M80x20_F_I_16, v2s_all_M80x20_F_I_16 },
	{ v2s_dif_M40x25_F_I_16, v2s_all_M40x25_F_I_16 },
	{ v2s_dif_M40x20_F_I_16, v2s_all_M40x20_F_I_16 },
    },
    {
	{ v2s_dif_U80x25_F_I_16, v2s_all_U80x25_F_I_16 },
	{ v2s_dif_U80x20_F_I_16, v2s_all_U80x20_F_I_16 },
	{ v2s_dif_U40x25_F_I_16, v2s_all_U40x25_F_I_16 },
	{ v2s_dif_U40x20_F_I_16, v2s_all_U40x20_F_I_16 },
    },
    {
	{ v2s_dif_H80x25_F_N_16, v2s_all_H80x25_F_N_16 },
	{ v2s_dif_H80x20_F_N_16, v2s_all_H80x20_F_N_16 },
	{ v2s_dif_H40x25_F_N_16, v2s_all_H40x25_F_N_16 },
	{ v2s_dif_H40x20_F_N_16, v2s_all_H40x20_F_N_16 },
    },
};

/* ========================================================================= */
/* Ⱦʬ - ɸ */

int (*vram2screen_list_H_N_16[4][4][2])(void) =
{
    {
	{ v2s_dif_C80x25_H_N_16, v2s_all_C80x25_H_N_16 },
	{ v2s_dif_C80x20_H_N_16, v2s_all_C80x20_H_N_16 },
	{ v2s_dif_C40x25_H_N_16, v2s_all_C40x25_H_N_16 },
	{ v2s_dif_C40x20_H_N_16, v2s_all_C40x20_H_N_16 },
    },
    {
	{ v2s_dif_M80x25_H_N_16, v2s_all_M80x25_H_N_16 },
	{ v2s_dif_M80x20_H_N_16, v2s_all_M80x20_H_N_16 },
	{ v2s_dif_M40x25_H_N_16, v2s_all_M40x25_H_N_16 },
	{ v2s_dif_M40x20_H_N_16, v2s_all_M40x20_H_N_16 },
    },
    {
	{ v2s_dif_U80x25_H_N_16, v2s_all_U80x25_H_N_16 },
	{ v2s_dif_U80x20_H_N_16, v2s_all_U80x20_H_N_16 },
	{ v2s_dif_U40x25_H_N_16, v2s_all_U40x25_H_N_16 },
	{ v2s_dif_U40x20_H_N_16, v2s_all_U40x20_H_N_16 },
    },
    {
	{ v2s_dif_H80x25_H_N_16, v2s_all_H80x25_H_N_16 },
	{ v2s_dif_H80x20_H_N_16, v2s_all_H80x20_H_N_16 },
	{ v2s_dif_H40x25_H_N_16, v2s_all_H40x25_H_N_16 },
	{ v2s_dif_H40x20_H_N_16, v2s_all_H40x20_H_N_16 },
    },
};

/* Ⱦʬ - 䴰 */

int (*vram2screen_list_H_P_16[4][4][2])(void) =
{
    {
	{ v2s_dif_C80x25_H_P_16, v2s_all_C80x25_H_P_16 },
	{ v2s_dif_C80x20_H_P_16, v2s_all_C80x20_H_P_16 },
	{ v2s_dif_C40x25_H_P_16, v2s_all_C40x25_H_P_16 },
	{ v2s_dif_C40x20_H_P_16, v2s_all_C40x20_H_P_16 },
    },
    {
	{ v2s_dif_M80x25_H_P_16, v2s_all_M80x25_H_P_16 },
	{ v2s_dif_M80x20_H_P_16, v2s_all_M80x20_H_P_16 },
	{ v2s_dif_M40x25_H_P_16, v2s_all_M40x25_H_P_16 },
	{ v2s_dif_M40x20_H_P_16, v2s_all_M40x20_H_P_16 },
    },
    {
	{ v2s_dif_U80x25_H_P_16, v2s_all_U80x25_H_P_16 },
	{ v2s_dif_U80x20_H_P_16, v2s_all_U80x20_H_P_16 },
	{ v2s_dif_U40x25_H_P_16, v2s_all_U40x25_H_P_16 },
	{ v2s_dif_U40x20_H_P_16, v2s_all_U40x20_H_P_16 },
    },
    {
	{ v2s_dif_H80x25_H_N_16, v2s_all_H80x25_H_N_16 },
	{ v2s_dif_H80x20_H_N_16, v2s_all_H80x20_H_N_16 },
	{ v2s_dif_H40x25_H_N_16, v2s_all_H40x25_H_N_16 },
	{ v2s_dif_H40x20_H_N_16, v2s_all_H40x20_H_N_16 },
    },
};

/* ========================================================================= */
#ifdef	SUPPORT_DOUBLE
/* ܥ - ɸ */

int (*vram2screen_list_D_N_16[4][4][2])(void) =
{
    {
	{ v2s_dif_C80x25_D_N_16, v2s_all_C80x25_D_N_16 },
	{ v2s_dif_C80x20_D_N_16, v2s_all_C80x20_D_N_16 },
	{ v2s_dif_C40x25_D_N_16, v2s_all_C40x25_D_N_16 },
	{ v2s_dif_C40x20_D_N_16, v2s_all_C40x20_D_N_16 },
    },
    {
	{ v2s_dif_M80x25_D_N_16, v2s_all_M80x25_D_N_16 },
	{ v2s_dif_M80x20_D_N_16, v2s_all_M80x20_D_N_16 },
	{ v2s_dif_M40x25_D_N_16, v2s_all_M40x25_D_N_16 },
	{ v2s_dif_M40x20_D_N_16, v2s_all_M40x20_D_N_16 },
    },
    {
	{ v2s_dif_U80x25_D_N_16, v2s_all_U80x25_D_N_16 },
	{ v2s_dif_U80x20_D_N_16, v2s_all_U80x20_D_N_16 },
	{ v2s_dif_U40x25_D_N_16, v2s_all_U40x25_D_N_16 },
	{ v2s_dif_U40x20_D_N_16, v2s_all_U40x20_D_N_16 },
    },
    {
	{ v2s_dif_H80x25_D_N_16, v2s_all_H80x25_D_N_16 },
	{ v2s_dif_H80x20_D_N_16, v2s_all_H80x20_D_N_16 },
	{ v2s_dif_H40x25_D_N_16, v2s_all_H40x25_D_N_16 },
	{ v2s_dif_H40x20_D_N_16, v2s_all_H40x20_D_N_16 },
    },
};

/* ܥ - åץ饤 */

int (*vram2screen_list_D_S_16[4][4][2])(void) =
{
    {
	{ v2s_dif_C80x25_D_S_16, v2s_all_C80x25_D_S_16 },
	{ v2s_dif_C80x20_D_S_16, v2s_all_C80x20_D_S_16 },
	{ v2s_dif_C40x25_D_S_16, v2s_all_C40x25_D_S_16 },
	{ v2s_dif_C40x20_D_S_16, v2s_all_C40x20_D_S_16 },
    },
    {
	{ v2s_dif_M80x25_D_S_16, v2s_all_M80x25_D_S_16 },
	{ v2s_dif_M80x20_D_S_16, v2s_all_M80x20_D_S_16 },
	{ v2s_dif_M40x25_D_S_16, v2s_all_M40x25_D_S_16 },
	{ v2s_dif_M40x20_D_S_16, v2s_all_M40x20_D_S_16 },
    },
    {
	{ v2s_dif_U80x25_D_S_16, v2s_all_U80x25_D_S_16 },
	{ v2s_dif_U80x20_D_S_16, v2s_all_U80x20_D_S_16 },
	{ v2s_dif_U40x25_D_S_16, v2s_all_U40x25_D_S_16 },
	{ v2s_dif_U40x20_D_S_16, v2s_all_U40x20_D_S_16 },
    },
    {
	{ v2s_dif_H80x25_D_N_16, v2s_all_H80x25_D_N_16 },
	{ v2s_dif_H80x20_D_N_16, v2s_all_H80x20_D_N_16 },
	{ v2s_dif_H40x25_D_N_16, v2s_all_H40x25_D_N_16 },
	{ v2s_dif_H40x20_D_N_16, v2s_all_H40x20_D_N_16 },
    },
};

/* ܥ - 󥿡졼 */

int (*vram2screen_list_D_I_16[4][4][2])(void) =
{
    {
	{ v2s_dif_C80x25_D_I_16, v2s_all_C80x25_D_I_16 },
	{ v2s_dif_C80x20_D_I_16, v2s_all_C80x20_D_I_16 },
	{ v2s_dif_C40x25_D_I_16, v2s_all_C40x25_D_I_16 },
	{ v2s_dif_C40x20_D_I_16, v2s_all_C40x20_D_I_16 },
    },
    {
	{ v2s_dif_M80x25_D_I_16, v2s_all_M80x25_D_I_16 },
	{ v2s_dif_M80x20_D_I_16, v2s_all_M80x20_D_I_16 },
	{ v2s_dif_M40x25_D_I_16, v2s_all_M40x25_D_I_16 },
	{ v2s_dif_M40x20_D_I_16, v2s_all_M40x20_D_I_16 },
    },
    {
	{ v2s_dif_U80x25_D_I_16, v2s_all_U80x25_D_I_16 },
	{ v2s_dif_U80x20_D_I_16, v2s_all_U80x20_D_I_16 },
	{ v2s_dif_U40x25_D_I_16, v2s_all_U40x25_D_I_16 },
	{ v2s_dif_U40x20_D_I_16, v2s_all_U40x20_D_I_16 },
    },
    {
	{ v2s_dif_H80x25_D_N_16, v2s_all_H80x25_D_N_16 },
	{ v2s_dif_H80x20_D_N_16, v2s_all_H80x20_D_N_16 },
	{ v2s_dif_H40x25_D_N_16, v2s_all_H40x25_D_N_16 },
	{ v2s_dif_H40x20_D_N_16, v2s_all_H40x20_D_N_16 },
    },
};
#endif	/* SUPPORT_DOUBLE */

/* ------------------------------------------------------------------------- */
/* ܥ - ɸ */

int (*vram2screen_list_F_N_16_d[4][4][2])(void) =
{
    {
	{ v2s_dif_C80x25_F_N_16_d, v2s_all_C80x25_F_N_16_d },
	{ v2s_dif_C80x20_F_N_16_d, v2s_all_C80x20_F_N_16_d },
	{ v2s_dif_C40x25_F_N_16_d, v2s_all_C40x25_F_N_16_d },
	{ v2s_dif_C40x20_F_N_16_d, v2s_all_C40x20_F_N_16_d },
    },
    {
	{ v2s_dif_M80x25_F_N_16_d, v2s_all_M80x25_F_N_16_d },
	{ v2s_dif_M80x20_F_N_16_d, v2s_all_M80x20_F_N_16_d },
	{ v2s_dif_M40x25_F_N_16_d, v2s_all_M40x25_F_N_16_d },
	{ v2s_dif_M40x20_F_N_16_d, v2s_all_M40x20_F_N_16_d },
    },
    {
	{ v2s_dif_U80x25_F_N_16_d, v2s_all_U80x25_F_N_16_d },
	{ v2s_dif_U80x20_F_N_16_d, v2s_all_U80x20_F_N_16_d },
	{ v2s_dif_U40x25_F_N_16_d, v2s_all_U40x25_F_N_16_d },
	{ v2s_dif_U40x20_F_N_16_d, v2s_all_U40x20_F_N_16_d },
    },
    {
	{ v2s_dif_H80x25_F_N_16, v2s_all_H80x25_F_N_16 },
	{ v2s_dif_H80x20_F_N_16, v2s_all_H80x20_F_N_16 },
	{ v2s_dif_H40x25_F_N_16, v2s_all_H40x25_F_N_16 },
	{ v2s_dif_H40x20_F_N_16, v2s_all_H40x20_F_N_16 },
    },
};

#ifdef	SUPPORT_DOUBLE
/* ܥ - ɸ */

int (*vram2screen_list_D_N_16_d[4][4][2])(void) =
{
    {
	{ v2s_dif_C80x25_D_N_16_d, v2s_all_C80x25_D_N_16_d },
	{ v2s_dif_C80x20_D_N_16_d, v2s_all_C80x20_D_N_16_d },
	{ v2s_dif_C40x25_D_N_16_d, v2s_all_C40x25_D_N_16_d },
	{ v2s_dif_C40x20_D_N_16_d, v2s_all_C40x20_D_N_16_d },
    },
    {
	{ v2s_dif_M80x25_D_N_16_d, v2s_all_M80x25_D_N_16_d },
	{ v2s_dif_M80x20_D_N_16_d, v2s_all_M80x20_D_N_16_d },
	{ v2s_dif_M40x25_D_N_16_d, v2s_all_M40x25_D_N_16_d },
	{ v2s_dif_M40x20_D_N_16_d, v2s_all_M40x20_D_N_16_d },
    },
    {
	{ v2s_dif_U80x25_D_N_16_d, v2s_all_U80x25_D_N_16_d },
	{ v2s_dif_U80x20_D_N_16_d, v2s_all_U80x20_D_N_16_d },
	{ v2s_dif_U40x25_D_N_16_d, v2s_all_U40x25_D_N_16_d },
	{ v2s_dif_U40x20_D_N_16_d, v2s_all_U40x20_D_N_16_d },
    },
    {
	{ v2s_dif_H80x25_D_N_16_d, v2s_all_H80x25_D_N_16_d },
	{ v2s_dif_H80x20_D_N_16_d, v2s_all_H80x20_D_N_16_d },
	{ v2s_dif_H40x25_D_N_16_d, v2s_all_H40x25_D_N_16_d },
	{ v2s_dif_H40x20_D_N_16_d, v2s_all_H40x20_D_N_16_d },
    },
};

/* ܥ - åץ饤 */

int (*vram2screen_list_D_S_16_d[4][4][2])(void) =
{
    {
	{ v2s_dif_C80x25_D_S_16_d, v2s_all_C80x25_D_S_16_d },
	{ v2s_dif_C80x20_D_S_16_d, v2s_all_C80x20_D_S_16_d },
	{ v2s_dif_C40x25_D_S_16_d, v2s_all_C40x25_D_S_16_d },
	{ v2s_dif_C40x20_D_S_16_d, v2s_all_C40x20_D_S_16_d },
    },
    {
	{ v2s_dif_M80x25_D_S_16_d, v2s_all_M80x25_D_S_16_d },
	{ v2s_dif_M80x20_D_S_16_d, v2s_all_M80x20_D_S_16_d },
	{ v2s_dif_M40x25_D_S_16_d, v2s_all_M40x25_D_S_16_d },
	{ v2s_dif_M40x20_D_S_16_d, v2s_all_M40x20_D_S_16_d },
    },
    {
	{ v2s_dif_U80x25_D_S_16_d, v2s_all_U80x25_D_S_16_d },
	{ v2s_dif_U80x20_D_S_16_d, v2s_all_U80x20_D_S_16_d },
	{ v2s_dif_U40x25_D_S_16_d, v2s_all_U40x25_D_S_16_d },
	{ v2s_dif_U40x20_D_S_16_d, v2s_all_U40x20_D_S_16_d },
    },
    {
	{ v2s_dif_H80x25_D_N_16_d, v2s_all_H80x25_D_N_16_d },
	{ v2s_dif_H80x20_D_N_16_d, v2s_all_H80x20_D_N_16_d },
	{ v2s_dif_H40x25_D_N_16_d, v2s_all_H40x25_D_N_16_d },
	{ v2s_dif_H40x20_D_N_16_d, v2s_all_H40x20_D_N_16_d },
    },
};

/* ܥ - 󥿡졼 */

int (*vram2screen_list_D_I_16_d[4][4][2])(void) =
{
    {
	{ v2s_dif_C80x25_D_I_16_d, v2s_all_C80x25_D_I_16_d },
	{ v2s_dif_C80x20_D_I_16_d, v2s_all_C80x20_D_I_16_d },
	{ v2s_dif_C40x25_D_I_16_d, v2s_all_C40x25_D_I_16_d },
	{ v2s_dif_C40x20_D_I_16_d, v2s_all_C40x20_D_I_16_d },
    },
    {
	{ v2s_dif_M80x25_D_I_16_d, v2s_all_M80x25_D_I_16_d },
	{ v2s_dif_M80x20_D_I_16_d, v2s_all_M80x20_D_I_16_d },
	{ v2s_dif_M40x25_D_I_16_d, v2s_all_M40x25_D_I_16_d },
	{ v2s_dif_M40x20_D_I_16_d, v2s_all_M40x20_D_I_16_d },
    },
    {
	{ v2s_dif_U80x25_D_I_16_d, v2s_all_U80x25_D_I_16_d },
	{ v2s_dif_U80x20_D_I_16_d, v2s_all_U80x20_D_I_16_d },
	{ v2s_dif_U40x25_D_I_16_d, v2s_all_U40x25_D_I_16_d },
	{ v2s_dif_U40x20_D_I_16_d, v2s_all_U40x20_D_I_16_d },
    },
    {
	{ v2s_dif_H80x25_D_N_16_d, v2s_all_H80x25_D_N_16_d },
	{ v2s_dif_H80x20_D_N_16_d, v2s_all_H80x20_D_N_16_d },
	{ v2s_dif_H40x25_D_N_16_d, v2s_all_H40x25_D_N_16_d },
	{ v2s_dif_H40x20_D_N_16_d, v2s_all_H40x20_D_N_16_d },
    },
};
#endif	/* SUPPORT_DOUBLE */

#endif	/* SUPPORT_16BPP */
